<?php

/**
 * @file
 * Contains \Drupal\drd\Agent\Action\V8\Info.
 */

namespace Drupal\drd\Agent\Action\V8;

/**
 * Provides a 'Info' code.
 */
class Info extends Base {
  /**
   * @inheritDoc
   */
  public function execute() {
    $config = \Drupal::configFactory()->get('system.site');
    // Initial set of information.
    $result = array(
      'root' => DRUPAL_ROOT,
      'version' => \Drupal::VERSION,
      'name' => $config->get('name'),
    );

    // Check run-time requirements and status information.
    $systemManager = \Drupal::getContainer()->get('system.manager');
    $result['requirements'] = $systemManager->listRequirements();

    $result['variables'] = $GLOBALS['config'];
    foreach ($GLOBALS as $key => $value) {
      if (!in_array($key, ['config', 'GLOBALS', 'autoloader', 'kernel', 'request'])) {
        $result['globals'][$key] = $value;
      }
    }

    return $result;
  }

}
