<?php

/**
 * @file
 * Contains \Drupal\drd\Crypt\BaseMethodInterface.
 */

namespace Drupal\drd\Crypt;

use Drupal\Core\Form\FormStateInterface;

/**
 * Provides an interface for encryption methods.
 *
 * @ingroup drd
 */
interface BaseMethodInterface {

  /**
   * @return string
   */
  public function getLabel();

  /**
   * @return bool
   */
  public function isAvailable();

  /**
   * @return array
   */
  public function getCipherMethods();

  /**
   * @param array $form
   * @param array $condition
   */
  public function settingsForm(array &$form, array $condition);

  /**
   * @param FormStateInterface $form_state
   * @return array
   */
  public function settingsFormValues(FormStateInterface $form_state);

  /**
   * @return string
   */
  public function getIV();

  /**
   * @param array $args
   * @return string
   */
  public function encrypt($args);

  /**
   * @param string $body
   * @param string $iv
   * @return array
   */
  public function decrypt($body, $iv);

}
