<?php

/**
 * @file
 * Contains \Drupal\drd\Entity\HostInterface.
 */

namespace Drupal\drd\Entity;

/**
 * Provides an interface for defining Host entities.
 *
 * @ingroup drd
 */
interface HostInterface extends BaseInterface {

  /**
   * @return string
   */
  public function getDrush();

  /**
   * @return string
   */
  public function getDrupalConsole();

  /**
   * @param array $properties
   * @return array
   */
  public function getCores($properties = []);

  /**
   * @param array $properties
   * @return array
   */
  public function getDomains($properties = []);

  /**
   * @return array
   */
  public function getSshSettings();

  /**
   * Determine IP addresses of all associated domains and store them with the
   * host.
   */
  public function updateIpAddresses();

  /**
   * @param string $name
   * @return HostInterface
   */
  public static function findOrCreateByHost($name);

}
