<?php

/**
 * @file
 * Contains \Drupal\drd\LibraryBuild.
 */

namespace Drupal\drd;

use Drupal\Core\Url;

/**
 * Class LibraryBuild.
 *
 * @package Drupal\drd
 */
class LibraryBuild {

  /**
   *
   */
  public function build(&$arguments) {
    $root = drupal_get_path('module', 'drd');
    $path = $root . '/build/drd.phar';
    if (isset($arguments['source']) && $arguments['source'] == 'local') {
      $url = Url::fromUserInput('/' . $path, ['absolute' => TRUE]);
      $arguments['url'] = $url->toString();
    }

    $phar = new \Phar($path, 0, 'drd.phar');
    $phar->buildFromDirectory($root . '/src/Agent');
    $phar->buildFromDirectory($root . '/src/Crypt');
    $phar->setStub($phar->createDefaultStub('index.php'));

    if (PHP_SAPI === 'cli') {
      // We can't determine our own URL and hence have to deliver the content
      // of the file as part of the request.
      $arguments['lib'] = base64_encode(file_get_contents($path));
    }
  }

}
