<?php

/**
 * @file
 * Contains \Drupal\drd\Plugin\Base.
 */

namespace Drupal\drd\Plugin\Action;

use Drupal\Core\Action\ActionBase;

/**
 * Base class for DRD Action plugins.
 */
abstract class Base extends ActionBase {

  protected $arguments = array();

  /**
   * @return string|bool
   */
  protected function getFollowUpAction() {
    return FALSE;
  }

  /**
   * @param string $id
   *
   * @return Base|bool
   */
  final public static function instance($id) {
    $type = \Drupal::service('plugin.manager.action');
    /** @var BaseEntityRemote $action */
    $action = $type->createInstance($id);
    if (empty($action) || !($action instanceof BaseInterface)) {
      return FALSE;
    }
    return $action;
  }

  /**
   * @inheritDoc
   */
  public function execute() {
    // TODO: Implement execute() method.
  }

  /**
   * @inheritDoc
   */
  final public function setActionArgument($key, $value) {
    $this->arguments[$key] = $value;
  }

  /**
   * @inheritDoc
   */
  final public function setArguments(array $arguments) {
    $this->arguments = $arguments;
  }

  /**
   * @inheritDoc
   */
  final public function getArguments() {
    return $this->arguments;
  }

}
