<?php

/**
 * @file
 * Contains \Drupal\drd\Plugin\Action\Info.
 */

namespace Drupal\drd\Plugin\Action;

/**
 * Provides a 'Info' action.
 *
 * @Action(
 *  id = "drd_action_info",
 *  label = @Translation("Info"),
 *  type = "drd_domain",
 * )
 */
class Info extends BaseEntityRemote {

  /**
   * @inheritdoc
   */
  public function executeAction($domain) {
    $response = parent::executeAction($domain);
    if ($response) {
      $domain
        ->set('name', $response['name'])
        ->cacheGlobals($response['globals'])
        ->cacheRequirements($response['requirements'])
        ->cacheVariables($response['variables'])
        ->save();
      return $response;
    }
    return FALSE;
  }

}
