<?php

/**
 * @file
 * Contains \Drupal\drd\Plugin\Action\Ping.
 */

namespace Drupal\drd\Plugin\Action;

/**
 * Provides a 'Ping' action.
 *
 * @Action(
 *  id = "drd_action_ping",
 *  label = @Translation("Ping"),
 *  type = "drd_domain",
 * )
 */
class Ping extends BaseEntityRemote {

  /**
   * @inheritdoc
   */
  public function executeAction($domain) {
    $response = parent::executeAction($domain);
    if ($response && $response['data'] == 'pong') {
      $this->response['output'] = $response['data'];
      $domain->set('installed', TRUE);
      return TRUE;
    }
    $domain->set('installed', FALSE);
    return FALSE;
  }

}
