<?php

/**
 * @file
 * Contains \Drupal\drd\Plugin\Auth\SharedSecret.
 */

namespace Drupal\drd\Plugin\Auth;

use Drupal\Core\Annotation\Translation;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\StringTranslation\StringTranslationTrait;
use Drupal\drd\Annotation\Auth;

/**
 * Plugin implementation of the 'shared_secret' DRD authentication.
 *
 * @Auth(
 *   id = "shared_secret",
 *   label = @Translation("DRD Auth: Shared Secret"),
 *   description = @Translation("TBD")
 * )
 */
class SharedSecret extends Base {
  use StringTranslationTrait;

  /**
   * {@inheritdoc}
   */
  public function settingsForm(array &$form, array $condition) {
    $form['secret'] = [
      '#type' => 'textfield',
      '#title' => $this->t('Shared secret'),
      '#default_value' => '',
      '#states' => [
        'required' => $condition,
      ],
    ];
  }

  /**
   * @inheritDoc
   */
  public function settingsFormValues(FormStateInterface $form_state) {
    return ['secret' => $form_state->getValue('secret'),];
  }

}
