<?php

namespace Drupal\drd\Plugin\Block;

use Drupal\Core\Annotation\Translation;
use Drupal\Core\Block\Annotation\Block;
use Drupal\drd\Entity\DomainInterface;

/**
 * Provides a 'Remote' block plugin.
 *
 * @Block(
 *   id = "drd_remote_block",
 *   admin_label = @Translation("DRD Remote Block"),
 *   deriver = "Drupal\drd\Plugin\Derivative\RemoteBlock"
 * )
 */
class Remote extends Base {

  /**
   * {@inheritdoc}
   */
  public function build() {
    if (!$this->isDrdContext()) {
      return [];
    }

    $entity = $this->getEntity();
    if (!($entity instanceof DomainInterface)) {
      return [];
    }

    list(, $module, $delta) = explode(':', $this->getPluginId());
    $content = $entity->getRemoteBlock($module, $delta);
    if (empty($content)) {
      return [];
    }

    $build = [];
    $build['remote_block']['#markup'] = $content;

    return $build;
  }

}
