<?php

/**
 * @file
 * Contains Drupal\drd\Plugin\QueueWorker\Base.php
 */

namespace Drupal\drd\Plugin\QueueWorker;

use Drupal\Core\Plugin\ContainerFactoryPluginInterface;
use Drupal\Core\Queue\QueueWorkerBase;
use Drupal\drd\Plugin\Action\BaseEntityInterface;
use Drupal\drd\Plugin\Action\BaseGlobalInterface;
use Drupal\drd\Plugin\Action\BaseInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Provides base functionality for the Drd Queue Workers.
 */
abstract class Base extends QueueWorkerBase implements ContainerFactoryPluginInterface {

  /**
   * @inheritDoc
   */
  public static function create(ContainerInterface $container, array $configuration, $plugin_id, $plugin_definition) {
    return new static($configuration, $plugin_id, $plugin_definition);
  }

  /**
   * {@inheritdoc}
   */
  public function processItem($data) {
    if (!empty($data->action) && $data->action instanceof BaseInterface) {
      $data->action->setArguments($data->arguments);
      if ($data->action instanceof BaseEntityInterface) {
        $data->action->executeAction($data->entity);
      }
      else if ($data->action instanceof BaseGlobalInterface) {
        $data->action->executeAction();
      }
    }
  }

}
