<?php

/**
 * @file
 * Contains \Drupal\drd\Widgets.
 */

namespace Drupal\drd;

use Drupal\Core\Block\BlockManager;
use Drupal\drd\Plugin\Block\Base;

/**
 * Easy access to the DRD widgets.
 */
class Widgets {

  /**
   * @return []
   */
  public function findWidgets($render) {
    $widgets = [];
    /** @var BlockManager $block_manager */
    $block_manager = \Drupal::service('plugin.manager.block');
    foreach ($block_manager->getDefinitions() as $definition) {
      if (isset($definition['tags']) && in_array('drd_widget', $definition['tags'])) {
        if (!isset($definition['weight'])) {
          $definition['weight'] = 0;
        }
        if ($render) {
          $widgets[$definition['weight']] = [
              '#type' => 'container',
              '#attributes' => [
                'class' => ['drd-widget'],
              ],
              '#weight' => $definition['weight'],
            ] + $block_manager->createInstance($definition['id'], [])->build();
        }
        else {
          $widgets[$definition['weight']] = $definition;
        }
      }
    }
    ksort($widgets);
    return $widgets;
  }

  /**
   * @return Base[]
   */
  public function getWidgets() {
    return $this->findWidgets(TRUE);
  }

}
